"""
    Blockdaemon REST API

    Blockdaemon REST API provides a RESTful and uniform way to access blockchain resources, with a rich and reusable model across multiple protocols/cryptocurrencies.  [Documentation](https://docs.blockdaemon.com/reference/rest-api-overview)  ### Currently supported protocols:  * algorand   * mainnet * avalanche    * mainnet-c/testnet-c * bitcoin   * mainnet/testnet * bitcoincash   * mainnet/testnet * dogecoin   * mainnet/testnet * ethereum   * mainnet/holesky/sepolia * fantom   * mainnet/testnet * litecoin   * mainnet/testnet * near   * mainnet/testnet * optimism   * mainnet * polkadot   * mainnet/westend * polygon   * mainnet/amoy * solana   * mainnet/testnet * stellar   * mainnet/testnet * tezos   * mainnet * tron   * mainnet/nile * xrp   * mainnet  ### Pagination Certain resources contain a lot of data, more than what's practical to return for a single request. With the help of pagination, the data is split across multiple responses. Each response returns a subset of the items requested, and a continuation token.  To get the next batch of items, copy the returned continuation token to the continuation query parameter and repeat the request with the new URL. In case no continuation token is returned, there is no more data available.   # noqa: E501

    The version of the OpenAPI document: 3.0.0
    Contact: support@blockdaemon.com
    Generated by: https://openapi-generator.tech
"""


import re  # noqa: F401
import sys  # noqa: F401

from ubiquity.ubiquity_openapi_client.api_client import ApiClient, Endpoint as _Endpoint
from ubiquity.ubiquity_openapi_client.model_utils import (  # noqa: F401
    check_allowed_values,
    check_validations,
    date,
    datetime,
    file_type,
    none_type,
    validate_and_convert_types
)
from ubiquity.ubiquity_openapi_client.model.accounts_balances import AccountsBalances
from ubiquity.ubiquity_openapi_client.model.accounts_obj import AccountsObj
from ubiquity.ubiquity_openapi_client.model.balances import Balances
from ubiquity.ubiquity_openapi_client.model.error import Error
from ubiquity.ubiquity_openapi_client.model.report import Report


class BalancesUTXOApi(object):
    """NOTE: This class is auto generated by OpenAPI Generator
    Ref: https://openapi-generator.tech

    Do not edit the class manually.
    """

    def __init__(self, api_client=None):
        if api_client is None:
            api_client = ApiClient()
        self.api_client = api_client

        def __get_list_of_balances_by_address(
            self,
            protocol="bitcoin",
            network="mainnet",
            address="1A1zP1eP5QGefi2DMPTfTL5SLmv7DivfNa",
            **kwargs
        ):
            """Get a List of Balances for an Address  # noqa: E501

            Returns a list of account balances by a user-defined account address for the supported currencies.  # noqa: E501
            This method makes a synchronous HTTP request by default. To make an
            asynchronous HTTP request, please pass async_req=True

            >>> thread = api.get_list_of_balances_by_address(protocol="bitcoin", network="mainnet", address="1A1zP1eP5QGefi2DMPTfTL5SLmv7DivfNa", async_req=True)
            >>> result = thread.get()

            Args:
                protocol (str): Protocol handle, one of:  `algorand`, `avalanche`, `bitcoin`, `bitcoincash`, `dogecoin`, `ethereum`, `fantom`, `litecoin`, `near`, `optimism`, `polkadot`, `polygon`, `solana`, `stellar`, `tezos`, `xrp`. . defaults to "bitcoin", must be one of ["bitcoin"]
                network (str): Which network to target. Available networks can be found in the list of supported protocols or with /{protocol}.. defaults to "mainnet", must be one of ["mainnet"]
                address (str): The account address of the protocol.. defaults to "1A1zP1eP5QGefi2DMPTfTL5SLmv7DivfNa", must be one of ["1A1zP1eP5QGefi2DMPTfTL5SLmv7DivfNa"]

            Keyword Args:
                assets (str): Comma-separated list of asset paths to filter. If the list is empty, or all elements are empty, this filter has no effect. Find all the asset paths on this [page](https://docs.blockdaemon.com/reference/available-currencies-and-tokens).. [optional]
                _return_http_data_only (bool): response data without head status
                    code and headers. Default is True.
                _preload_content (bool): if False, the urllib3.HTTPResponse object
                    will be returned without reading/decoding response data.
                    Default is True.
                _request_timeout (int/float/tuple): timeout setting for this request. If
                    one number provided, it will be total request timeout. It can also
                    be a pair (tuple) of (connection, read) timeouts.
                    Default is None.
                _check_input_type (bool): specifies if type checking
                    should be done one the data sent to the server.
                    Default is True.
                _check_return_type (bool): specifies if type checking
                    should be done one the data received from the server.
                    Default is True.
                _host_index (int/None): specifies the index of the server
                    that we want to use.
                    Default is read from the configuration.
                async_req (bool): execute request asynchronously

            Returns:
                Balances
                    If the method is called asynchronously, returns the request
                    thread.
            """
            kwargs['async_req'] = kwargs.get(
                'async_req', False
            )
            kwargs['_return_http_data_only'] = kwargs.get(
                '_return_http_data_only', True
            )
            kwargs['_preload_content'] = kwargs.get(
                '_preload_content', True
            )
            kwargs['_request_timeout'] = kwargs.get(
                '_request_timeout', None
            )
            kwargs['_check_input_type'] = kwargs.get(
                '_check_input_type', True
            )
            kwargs['_check_return_type'] = kwargs.get(
                '_check_return_type', True
            )
            kwargs['_host_index'] = kwargs.get('_host_index')
            kwargs['protocol'] = \
                protocol
            kwargs['network'] = \
                network
            kwargs['address'] = \
                address
            return self.call_with_http_info(**kwargs)

        self.get_list_of_balances_by_address = _Endpoint(
            settings={
                'response_type': (Balances,),
                'auth': [
                    'apiKeyAuthHeader',
                    'bearerAuth'
                ],
                'endpoint_path': '/{protocol}/{network}/account/{address}',
                'operation_id': 'get_list_of_balances_by_address',
                'http_method': 'GET',
                'servers': None,
            },
            params_map={
                'all': [
                    'protocol',
                    'network',
                    'address',
                    'assets',
                ],
                'required': [
                    'protocol',
                    'network',
                    'address',
                ],
                'nullable': [
                ],
                'enum': [
                ],
                'validation': [
                ]
            },
            root_map={
                'validations': {
                },
                'allowed_values': {
                },
                'openapi_types': {
                    'protocol':
                        (str,),
                    'network':
                        (str,),
                    'address':
                        (str,),
                    'assets':
                        (str,),
                },
                'attribute_map': {
                    'protocol': 'protocol',
                    'network': 'network',
                    'address': 'address',
                    'assets': 'assets',
                },
                'location_map': {
                    'protocol': 'path',
                    'network': 'path',
                    'address': 'path',
                    'assets': 'query',
                },
                'collection_format_map': {
                }
            },
            headers_map={
                'accept': [
                    'application/json'
                ],
                'content_type': [],
            },
            api_client=api_client,
            callable=__get_list_of_balances_by_address
        )

        def __get_list_of_balances_by_addresses(
            self,
            accounts_obj,
            protocol="bitcoin",
            network="mainnet",
            **kwargs
        ):
            """Get a List of Balances for Multiple Adresses  # noqa: E501

            Returns a list of account balances by a user-defined list of account addresses for the supported currencies. The maximum of account addresses allowed in the filter is 10.   # noqa: E501
            This method makes a synchronous HTTP request by default. To make an
            asynchronous HTTP request, please pass async_req=True

            >>> thread = api.get_list_of_balances_by_addresses(accounts_obj, protocol="bitcoin", network="mainnet", async_req=True)
            >>> result = thread.get()

            Args:
                accounts_obj (AccountsObj):
                protocol (str): Protocol handle, one of:  `algorand`, `avalanche`, `bitcoin`, `bitcoincash`, `dogecoin`, `ethereum`, `fantom`, `litecoin`, `near`, `optimism`, `polkadot`, `polygon`, `solana`, `stellar`, `tezos`, `xrp`. . defaults to "bitcoin", must be one of ["bitcoin"]
                network (str): Which network to target. Available networks can be found in the list of supported protocols or with /{protocol}.. defaults to "mainnet", must be one of ["mainnet"]

            Keyword Args:
                assets (str): Comma-separated list of asset paths to filter. If the list is empty, or all elements are empty, this filter has no effect. Find all the asset paths on this [page](https://docs.blockdaemon.com/reference/available-currencies-and-tokens).. [optional]
                _return_http_data_only (bool): response data without head status
                    code and headers. Default is True.
                _preload_content (bool): if False, the urllib3.HTTPResponse object
                    will be returned without reading/decoding response data.
                    Default is True.
                _request_timeout (int/float/tuple): timeout setting for this request. If
                    one number provided, it will be total request timeout. It can also
                    be a pair (tuple) of (connection, read) timeouts.
                    Default is None.
                _check_input_type (bool): specifies if type checking
                    should be done one the data sent to the server.
                    Default is True.
                _check_return_type (bool): specifies if type checking
                    should be done one the data received from the server.
                    Default is True.
                _host_index (int/None): specifies the index of the server
                    that we want to use.
                    Default is read from the configuration.
                async_req (bool): execute request asynchronously

            Returns:
                AccountsBalances
                    If the method is called asynchronously, returns the request
                    thread.
            """
            kwargs['async_req'] = kwargs.get(
                'async_req', False
            )
            kwargs['_return_http_data_only'] = kwargs.get(
                '_return_http_data_only', True
            )
            kwargs['_preload_content'] = kwargs.get(
                '_preload_content', True
            )
            kwargs['_request_timeout'] = kwargs.get(
                '_request_timeout', None
            )
            kwargs['_check_input_type'] = kwargs.get(
                '_check_input_type', True
            )
            kwargs['_check_return_type'] = kwargs.get(
                '_check_return_type', True
            )
            kwargs['_host_index'] = kwargs.get('_host_index')
            kwargs['protocol'] = \
                protocol
            kwargs['network'] = \
                network
            kwargs['accounts_obj'] = \
                accounts_obj
            return self.call_with_http_info(**kwargs)

        self.get_list_of_balances_by_addresses = _Endpoint(
            settings={
                'response_type': (AccountsBalances,),
                'auth': [
                    'apiKeyAuthHeader',
                    'bearerAuth'
                ],
                'endpoint_path': '/{protocol}/{network}/accounts/',
                'operation_id': 'get_list_of_balances_by_addresses',
                'http_method': 'POST',
                'servers': None,
            },
            params_map={
                'all': [
                    'protocol',
                    'network',
                    'accounts_obj',
                    'assets',
                ],
                'required': [
                    'protocol',
                    'network',
                    'accounts_obj',
                ],
                'nullable': [
                ],
                'enum': [
                ],
                'validation': [
                ]
            },
            root_map={
                'validations': {
                },
                'allowed_values': {
                },
                'openapi_types': {
                    'protocol':
                        (str,),
                    'network':
                        (str,),
                    'accounts_obj':
                        (AccountsObj,),
                    'assets':
                        (str,),
                },
                'attribute_map': {
                    'protocol': 'protocol',
                    'network': 'network',
                    'assets': 'assets',
                },
                'location_map': {
                    'protocol': 'path',
                    'network': 'path',
                    'accounts_obj': 'body',
                    'assets': 'query',
                },
                'collection_format_map': {
                }
            },
            headers_map={
                'accept': [
                    'application/json'
                ],
                'content_type': [
                    'application/json'
                ]
            },
            api_client=api_client,
            callable=__get_list_of_balances_by_addresses
        )

        def __get_report_by_address(
            self,
            protocol="polkadot",
            network="mainnet",
            address="12yi4uHFbnSUryffXT7Xq92fbGC3iXvCs3vz9HjVgpb4sBvL",
            **kwargs
        ):
            """Get a Financial Report for an Address Between a Time Period  # noqa: E501

            Returns a financial report by a user-defined account address between a time period. Default timescale is within the last 30 days.   # noqa: E501
            This method makes a synchronous HTTP request by default. To make an
            asynchronous HTTP request, please pass async_req=True

            >>> thread = api.get_report_by_address(protocol="polkadot", network="mainnet", address="12yi4uHFbnSUryffXT7Xq92fbGC3iXvCs3vz9HjVgpb4sBvL", async_req=True)
            >>> result = thread.get()

            Args:
                protocol (str): Protocol handle, one of: `algorand`, `fantom`, `polkadot`, `polygon`, `stellar` `tezos`, `xrp`. . defaults to "polkadot", must be one of ["polkadot"]
                network (str): Which network to target. Available networks can be found in the list of supported protocols or with /{protocol}.. defaults to "mainnet", must be one of ["mainnet"]
                address (str): The account address of the protocol.. defaults to "12yi4uHFbnSUryffXT7Xq92fbGC3iXvCs3vz9HjVgpb4sBvL", must be one of ["12yi4uHFbnSUryffXT7Xq92fbGC3iXvCs3vz9HjVgpb4sBvL"]

            Keyword Args:
                _from (int): The Unix Timestamp from where to start.. [optional]
                to (int): The Unix Timestamp from where to end.. [optional]
                page_token (str): The token to retrieve more items in the next request. Use the `next_page_token` returned from the previous response for this parameter.. [optional]
                page_size (int): The max number of items to return in a response. Defaults to 50k and is capped at 100k. . [optional]
                _return_http_data_only (bool): response data without head status
                    code and headers. Default is True.
                _preload_content (bool): if False, the urllib3.HTTPResponse object
                    will be returned without reading/decoding response data.
                    Default is True.
                _request_timeout (int/float/tuple): timeout setting for this request. If
                    one number provided, it will be total request timeout. It can also
                    be a pair (tuple) of (connection, read) timeouts.
                    Default is None.
                _check_input_type (bool): specifies if type checking
                    should be done one the data sent to the server.
                    Default is True.
                _check_return_type (bool): specifies if type checking
                    should be done one the data received from the server.
                    Default is True.
                _host_index (int/None): specifies the index of the server
                    that we want to use.
                    Default is read from the configuration.
                async_req (bool): execute request asynchronously

            Returns:
                Report
                    If the method is called asynchronously, returns the request
                    thread.
            """
            kwargs['async_req'] = kwargs.get(
                'async_req', False
            )
            kwargs['_return_http_data_only'] = kwargs.get(
                '_return_http_data_only', True
            )
            kwargs['_preload_content'] = kwargs.get(
                '_preload_content', True
            )
            kwargs['_request_timeout'] = kwargs.get(
                '_request_timeout', None
            )
            kwargs['_check_input_type'] = kwargs.get(
                '_check_input_type', True
            )
            kwargs['_check_return_type'] = kwargs.get(
                '_check_return_type', True
            )
            kwargs['_host_index'] = kwargs.get('_host_index')
            kwargs['protocol'] = \
                protocol
            kwargs['network'] = \
                network
            kwargs['address'] = \
                address
            return self.call_with_http_info(**kwargs)

        self.get_report_by_address = _Endpoint(
            settings={
                'response_type': (Report,),
                'auth': [
                    'apiKeyAuthHeader',
                    'bearerAuth'
                ],
                'endpoint_path': '/{protocol}/{network}/account/{address}/report',
                'operation_id': 'get_report_by_address',
                'http_method': 'GET',
                'servers': None,
            },
            params_map={
                'all': [
                    'protocol',
                    'network',
                    'address',
                    '_from',
                    'to',
                    'page_token',
                    'page_size',
                ],
                'required': [
                    'protocol',
                    'network',
                    'address',
                ],
                'nullable': [
                ],
                'enum': [
                ],
                'validation': [
                ]
            },
            root_map={
                'validations': {
                },
                'allowed_values': {
                },
                'openapi_types': {
                    'protocol':
                        (str,),
                    'network':
                        (str,),
                    'address':
                        (str,),
                    '_from':
                        (int,),
                    'to':
                        (int,),
                    'page_token':
                        (str,),
                    'page_size':
                        (int,),
                },
                'attribute_map': {
                    'protocol': 'protocol',
                    'network': 'network',
                    'address': 'address',
                    '_from': 'from',
                    'to': 'to',
                    'page_token': 'page_token',
                    'page_size': 'page_size',
                },
                'location_map': {
                    'protocol': 'path',
                    'network': 'path',
                    'address': 'path',
                    '_from': 'query',
                    'to': 'query',
                    'page_token': 'query',
                    'page_size': 'query',
                },
                'collection_format_map': {
                }
            },
            headers_map={
                'accept': [
                    'application/json'
                ],
                'content_type': [],
            },
            api_client=api_client,
            callable=__get_report_by_address
        )
